=== debian/changelog ===
milkytracker (1.02.00.1+dfsg-1+deb10u1+dde) unstable; urgency=medium

  * update

 -- Debian Multimedia Team <debian-multimedia@lists.debian.org>  Fri, 18 Jun 2021 17:52:19 +0800

milkytracker (1.02.00+dfsg-1+deb10u1) buster; urgency=medium

  * CVE-2020-15569 (Closes: #964797)
  * CVE-2019-14464, CVE-2019-14496, CVE-2019-14497 (Closes: #933964)

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 18 Sep 2020 20:30:05 +0200
