=== debian/changelog ===
milkytracker (1.03.00+dfsg-2build1) jammy; urgency=medium

  * No-change rebuild against librtmidi6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 03:30:55 +0000

milkytracker (1.03.00+dfsg-2) unstable; urgency=medium

  * Team upload.

  * Add patch to build with C++11 (Closes: #1000855)
  * Refresh patches (and add descriptions)
  * Apply 'wrap-and-sort -ast'
  * Add salsa-ci configuration
  * Add myself to copyright holders...
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Nov 2021 17:29:52 +0100

milkytracker (1.03.00+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * d/upstream/metadata: added.
  * d/copyright:
    - added Upstream-Contact.
    - update copyright years.
    - drop wildcard-matches for files not shipped anymore.
  * Bump debhelper version to 13.
  * Bump standards version to 4.5.0.
  * d/patches/*: comment out upstreamed patches.
  * Patched away privacy-breach that is for very old IE.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 11 Dec 2020 07:10:08 +0100

milkytracker (1.02.00+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for use-after-free in the PlayerGeneric
    destructor (CVE-2020-15569) (Closes: #964797)
  * debian/control: Update Homepage to the current one.

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Jul 2020 16:26:05 +0300
