## milkytracker 1.04.00+dfsg

=== debian/changelog ===
milkytracker (1.04.00+dfsg-1) unstable; urgency=medium

  * New upstream version. (Closes: #1016578)
    CVE-2022-34927 - stack overflow via the component LoaderXM::load
  * Bump standards version to 4.6.2.
  * d/control: update maintainer address.

 -- Gürkan Myczko <tar@debian.org>  Sun, 30 Jul 2023 13:44:04 +0200
