=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: milkytracker
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
- Gürkan Myczko <gurkan@phys.ethz.ch>,
+ Gürkan Myczko <tar@debian.org>,
  James Cowgill <jcowgill@debian.org>,
 Build-Depends:
  cmake,
@@ -18,7 +17,7 @@
  libzzip-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/multimedia-team/milkytracker.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/milkytracker
 Homepage: https://milkytracker.org/
